freeslot(
	"sfx_bigjum",
	"sfx_dying",
	"sfx_crash",
	"S_DEAD1",
	"S_DEAD2",
	"S_DEAD3",
	"S_DEAD4",
	"S_DEAD5",
	"S_DEAD6",
	"S_DEAD7",
	"S_DEAD8",
	"S_DEAD9",
	"S_DEAD10"
)

--sfx captions
sfxinfo[sfx_bigjum].caption = "Big jump"
sfxinfo[sfx_dying].caption = "Ghost noises"
sfxinfo[sfx_crash].caption = "Crash"

--reset variables
local resetvars = function(p)
	p.canShockwave = false
	p.diving = false
	p.jumps = 0
	p.djghost = 0
	p.defaultjumppower = 15
	p.jumppower = defaultjumppower
	p.dead = false
	p.deathfade = 0
	p.imrobotniik = true
end

addHook("PlayerSpawn", function(p)
	resetvars(p)
end)

local function shockwave(mobj)
	P_NukeEnemies(mobj, mobj, 330*FRACUNIT)
	P_StartQuake(10*FRACUNIT, 7)
	S_StartSound(mobj, sfx_crash)
end

local function supershockwave(mobj)
	P_NukeEnemies(mobj, mobj, 1200*FRACUNIT)
	P_StartQuake(10*FRACUNIT, 7)
	S_StartSound(mobj, sfx_bkpoof)
end

addHook("PlayerThink",function(p)
	if p.mo and p.mo.skin == "robotniik" and p.mo.valid then
		if p.dead == false then
			if not P_IsObjectOnGround(p.mo) then
				p.canShockwave = true
			end
			
			if P_IsObjectOnGround(p.mo) or P_IsObjectInGoop(p.mo) or p.mo.eflags&MFE_TOUCHLAVA or p.powers[pw_carry] == CR_MINECART or p.powers[pw_carry] == CR_ROLLOUT then
				p.jumps = 0
				if p.canShockwave == true and p.diving == true then --create damaging shockwave
					p.canShockwave = false
					p.diving = false
					if p.powers[pw_super] then
						P_FlashPal(p, PAL_NUKE, 5)
						supershockwave(p.mo)
					else
						shockwave(p.mo)
					end
				end
			end
			
			if p.powers[pw_carry] == CR_GENERIC or p.powers[pw_carry] == CR_PLAYER or p.powers[pw_carry] == CR_NIGHTSMODE or p.powers[pw_carry] == CR_NIGHTSFALL or p.powers[pw_carry] == CR_BRAKGOOP or p.powers[pw_carry] == CR_ZOOMTUBE or p.powers[pw_carry] == CR_ROPEHANG or p.powers[pw_carry] == CR_MACESPIN or p.powers[pw_carry] == CR_PTERABYTE or p.powers[pw_carry] == CR_DUSTDEVIL then
				p.jumps = 0
				if p.canShockwave == true and p.diving == true then --disable the stuffs
					p.canShockwave = false
					p.diving = false
				end
			end
			
			if p.mo.eflags&MFE_SPRUNG and p.diving == true then --power spring!
				p.canShockwave = false
				p.diving = false
				S_StartSound(mobj, sfx_sprong)
				p.mo.momx = p.mo.momx * 6 / 4
				p.mo.momy = p.mo.momy * 6 / 4
				p.mo.momz = p.mo.momz * 6 / 4
			end
			
			--ghost effect
			if p.diving == true then
				p.djghost = 0
				P_SpawnGhostMobj(p.mo)
				P_SetObjectMomZ(p.mo, -1*FRACUNIT, true)
			end
			
			--double jump ghost effect
			if p.djghost > 0 then
				p.djghost = p.djghost - 1
				P_SpawnGhostMobj(p.mo)
			end
			
			--get underwater jump height
			if p.mo.eflags&MFE_UNDERWATER and not p.powers[pw_super] then
				p.jumppower = p.defaultjumppower * 3 / 4
			else
				p.jumppower = p.defaultjumppower
			end
			
			--super jump power
			if p.powers[pw_super] then
				p.jumppower = p.defaultjumppower * 6/4
			elseif p.powers[pw_super] and p.mo.eflags&MFE_UNDERWATER then
				p.jumppower = p.defaultjumppower
			end
		end
	end
end)

--ability
addHook("AbilitySpecial", function(p)
	if p.mo.skin != "robotniik"
		return 
	end
	
	if not P_IsObjectInGoop(p.mo) then
		p.jumps = p.jumps + 1
	end
	
	if p.jumps == 1 then
		P_SetObjectMomZ(p.mo,p.jumppower*FRACUNIT)
		S_StartSound(p.mo, sfx_jump)
		p.djghost = 3
	elseif p.jumps == 2 then
		P_SetObjectMomZ(p.mo,p.jumppower*FRACUNIT)
		S_StartSound(p.mo, sfx_bigjum)
		p.djghost = 6
	elseif p.jumps == 3 then
		--stomp attack
		p.diving = true
		P_SetObjectMomZ(p.mo,-38*FRACUNIT)
		S_StartSound(p.mo, sfx_s3k51)
	end
	
	p.pflags = $|PF_THOKKED
	return true
end)

--player death states
states[S_DEAD1] = {
        sprite = SPR_PLAY,
        frame = TR_TRANS10|A,
        tics = 3,
        nextstate = S_DEAD2
}

states[S_DEAD2] = {
        sprite = SPR_PLAY,
        frame = TR_TRANS20|A,
        tics = 3,
        nextstate = S_DEAD3
}

states[S_DEAD3] = {
        sprite = SPR_PLAY,
        frame = TR_TRANS30|A,
        tics = 3,
        nextstate = S_DEAD4
}

states[S_DEAD4] = {
        sprite = SPR_PLAY,
        frame = TR_TRANS40|A,
        tics = 3,
        nextstate = S_DEAD5
}

states[S_DEAD5] = {
        sprite = SPR_PLAY,
        frame = TR_TRANS50|A,
        tics = 3,
        nextstate = S_DEAD6
}

states[S_DEAD6] = {
        sprite = SPR_PLAY,
        frame = TR_TRANS60|A,
        tics = 3,
        nextstate = S_DEAD7
}

states[S_DEAD7] = {
        sprite = SPR_PLAY,
        frame = TR_TRANS70|A,
        tics = 3,
        nextstate = S_DEAD8
}

states[S_DEAD8] = {
        sprite = SPR_PLAY,
        frame = TR_TRANS80|A,
        tics = 3,
        nextstate = S_DEAD9
}

states[S_DEAD9] = {
        sprite = SPR_PLAY,
        frame = TR_TRANS90|A,
        tics = 3,
        nextstate = S_DEAD10
}

states[S_DEAD10] = {
        sprite = SPR_NULL,
        frame = TR_TRANS10|A,
		tics = -1
}

--player death stuff
addHook("MobjThinker", function(mo)
	if mo.skin == "robotniik" and mo.player and mo.valid then
		local p = mo.player
		if p.dead == true then
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			--fade
			p.deathfade = p.deathfade + 1
			if p.deathfade == 5 then --god i hate this piece of code. please do not look at it.
				p.mo.state = S_DEAD1
			elseif p.deathfade == 10 then
				p.mo.state = S_DEAD2
			elseif p.deathfade == 15 then
				p.mo.state = S_DEAD3
			elseif p.deathfade == 20 then
				p.mo.state = S_DEAD4
			elseif p.deathfade == 25 then
				p.mo.state = S_DEAD5
			elseif p.deathfade == 30 then
				p.mo.state = S_DEAD6
			elseif p.deathfade == 35 then
				p.mo.state = S_DEAD7
			elseif p.deathfade == 40 then
				p.mo.state = S_DEAD8
			elseif p.deathfade == 45 then
				p.mo.state = S_DEAD9
			elseif p.deathfade == 50 then
				p.mo.state = S_DEAD10
			end --thank god this crap is over
		end
	end
end, MT_PLAYER)

addHook("MobjDeath", function(target, inflictor, source, damage, damagetype)
	if target.skin == "robotniik" and target.player and target.valid then
		local p = target.player
		p.dead = true
		S_StartSound(p.mo, sfx_dying)
	end
end, MT_PLAYER)